// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: connector.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ConnectorClient is the client API for Connector service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ConnectorClient interface {
	Create(ctx context.Context, in *ConnectorModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ConnectorModel, error)
	Update(ctx context.Context, in *ConnectorModel, opts ...grpc.CallOption) (*ConnectorModel, error)
	List(ctx context.Context, in *ConnectorReq, opts ...grpc.CallOption) (Connector_ListClient, error)
}

type connectorClient struct {
	cc grpc.ClientConnInterface
}

func NewConnectorClient(cc grpc.ClientConnInterface) ConnectorClient {
	return &connectorClient{cc}
}

func (c *connectorClient) Create(ctx context.Context, in *ConnectorModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.Connector/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *connectorClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.Connector/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *connectorClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ConnectorModel, error) {
	out := new(ConnectorModel)
	err := c.cc.Invoke(ctx, "/botMs.Connector/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *connectorClient) Update(ctx context.Context, in *ConnectorModel, opts ...grpc.CallOption) (*ConnectorModel, error) {
	out := new(ConnectorModel)
	err := c.cc.Invoke(ctx, "/botMs.Connector/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *connectorClient) List(ctx context.Context, in *ConnectorReq, opts ...grpc.CallOption) (Connector_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &Connector_ServiceDesc.Streams[0], "/botMs.Connector/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &connectorListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Connector_ListClient interface {
	Recv() (*ConnectorModel, error)
	grpc.ClientStream
}

type connectorListClient struct {
	grpc.ClientStream
}

func (x *connectorListClient) Recv() (*ConnectorModel, error) {
	m := new(ConnectorModel)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// ConnectorServer is the server API for Connector service.
// All implementations must embed UnimplementedConnectorServer
// for forward compatibility
type ConnectorServer interface {
	Create(context.Context, *ConnectorModel) (*proto.IdRequest, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*ConnectorModel, error)
	Update(context.Context, *ConnectorModel) (*ConnectorModel, error)
	List(*ConnectorReq, Connector_ListServer) error
	mustEmbedUnimplementedConnectorServer()
}

// UnimplementedConnectorServer must be embedded to have forward compatible implementations.
type UnimplementedConnectorServer struct {
}

func (UnimplementedConnectorServer) Create(context.Context, *ConnectorModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedConnectorServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedConnectorServer) Get(context.Context, *proto.IdRequest) (*ConnectorModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedConnectorServer) Update(context.Context, *ConnectorModel) (*ConnectorModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedConnectorServer) List(*ConnectorReq, Connector_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedConnectorServer) mustEmbedUnimplementedConnectorServer() {}

// UnsafeConnectorServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ConnectorServer will
// result in compilation errors.
type UnsafeConnectorServer interface {
	mustEmbedUnimplementedConnectorServer()
}

func RegisterConnectorServer(s grpc.ServiceRegistrar, srv ConnectorServer) {
	s.RegisterService(&Connector_ServiceDesc, srv)
}

func _Connector_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConnectorModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConnectorServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Connector/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConnectorServer).Create(ctx, req.(*ConnectorModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Connector_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConnectorServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Connector/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConnectorServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Connector_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConnectorServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Connector/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConnectorServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Connector_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ConnectorModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConnectorServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Connector/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConnectorServer).Update(ctx, req.(*ConnectorModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Connector_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ConnectorReq)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ConnectorServer).List(m, &connectorListServer{stream})
}

type Connector_ListServer interface {
	Send(*ConnectorModel) error
	grpc.ServerStream
}

type connectorListServer struct {
	grpc.ServerStream
}

func (x *connectorListServer) Send(m *ConnectorModel) error {
	return x.ServerStream.SendMsg(m)
}

// Connector_ServiceDesc is the grpc.ServiceDesc for Connector service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Connector_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.Connector",
	HandlerType: (*ConnectorServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Connector_Create_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Connector_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Connector_Get_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Connector_Update_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _Connector_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "connector.proto",
}
